<?php

namespace app\controllers\mikrotik\capsman;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\capsman\Security;

class SecurityController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanCreateSecurity'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDeleteSecurity'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDisableSecurity'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanEnableSecurity'],
                    ], [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanUpdateSecurity'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Security();
        return var_dump($model->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Security();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Security']['encryption'] != '') {
                $opt = implode(",", $_POST['Security']['encryption']);
                $model->encryption = $opt;
            }
            if ($_POST['Security']['eap_methods'] != '') {
                $opt = implode(",", $_POST['Security']['eap_methods']);
                $model->eap_methods = $opt;
            }
            if ($_POST['Security']['authentication_types'] != '') {
                $opt = implode(",", $_POST['Security']['authentication_types']);
                $model->authentication_types = $opt;
            }
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        } else {
            $model->get($id);
        }
        $model->eap_methods = explode(',', $model->eap_methods);
        $model->encryption = explode(',', $model->encryption);
        $model->authentication_types = explode(',', $model->authentication_types);
        return $this->render('/mikrotik/capsman/security', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'keys' => $model->getKeys(),
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Security();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Security']['encryption'] != '') {
                $opt = implode(",", $_POST['Security']['encryption']);
                $model->encryption = $opt;
            }
            if ($_POST['Security']['eap_methods'] != '') {
                $opt = implode(",", $_POST['Security']['eap_methods']);
                $model->eap_methods = $opt;
            }
            if ($_POST['Security']['authentication_types'] != '') {
                $opt = implode(",", $_POST['Security']['authentication_types']);
                $model->authentication_types = $opt;
            }
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        }

        return $this->render('/mikrotik/capsman/security', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'keys' => $model->getKeys(),
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Security();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Security();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Security();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

}
